﻿using HarmonyLib;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MoreStorages : Mod
{
    public static AssetBundle assetbundle;

    IEnumerator Start()
    {
        HNotification notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "Loading MoreStorages...");

        var bundleLoadRequest = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("morestorages.assets"));
        yield return bundleLoadRequest;
        assetbundle = bundleLoadRequest.assetBundle;

        List<Item_Base> list = Traverse.Create(typeof(ItemManager)).Field("allAvailableItems").GetValue<List<Item_Base>>();

        Item_Base Placeable_MoreStorages_MinecraftChest = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("Placeable_MoreStorages_MinecraftChest");
        Placeable_MoreStorages_MinecraftChest.Initialize(9845, "Placeable_MoreStorages_MinecraftChest", 1);
        list.Add(Placeable_MoreStorages_MinecraftChest);
        RegisterChest(Placeable_MoreStorages_MinecraftChest);

        Item_Base Placeable_MoreStorages_Barrel = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("Placeable_MoreStorages_Barrel");
        Placeable_MoreStorages_Barrel.Initialize(9846, "Placeable_MoreStorages_Barrel", 1);
        list.Add(Placeable_MoreStorages_Barrel);
        RegisterChest(Placeable_MoreStorages_Barrel);

        Item_Base Placeable_MoreStorages_Crate = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("Placeable_MoreStorages_Crate");
        Placeable_MoreStorages_Crate.Initialize(9847, "Placeable_MoreStorages_Crate", 1);
        list.Add(Placeable_MoreStorages_Crate);
        RegisterChest(Placeable_MoreStorages_Crate);

        Item_Base Placeable_MoreStorages_Luggage = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("Placeable_MoreStorages_Luggage");
        Placeable_MoreStorages_Luggage.Initialize(9848, "Placeable_MoreStorages_Luggage", 1);
        list.Add(Placeable_MoreStorages_Luggage);
        RegisterChest(Placeable_MoreStorages_Luggage);

        Item_Base Placeable_MoreStorages_MedievalChest = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("Placeable_MoreStorages_MedievalChest");
        Placeable_MoreStorages_MedievalChest.Initialize(9849, "Placeable_MoreStorages_MedievalChest", 1);
        list.Add(Placeable_MoreStorages_MedievalChest);
        RegisterChest(Placeable_MoreStorages_MedievalChest);

        Item_Base Placeable_MoreStorages_Package = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("Placeable_MoreStorages_Package");
        Placeable_MoreStorages_Package.Initialize(9850, "Placeable_MoreStorages_Package", 1);
        list.Add(Placeable_MoreStorages_Package);
        RegisterChest(Placeable_MoreStorages_Package);


        Traverse.Create(typeof(ItemManager)).Field("allAvailableItems").SetValue(list);

        notification.Close();
        Debug.Log("MoreStorages has been successfully loaded!");
    }

    void RegisterChest(Item_Base i)
    {
        Storage_Small prefab = i.settings_buildable.GetBlockPrefab(0) as Storage_Small;
        if ((AnimatorMessageForwarder)Traverse.Create(prefab).Field("animatorMessageForwarder").GetValue() == null)
        {
            AnimatorMessageForwarder anim = prefab.gameObject.AddComponent<AnimatorMessageForwarder>();
            Traverse.Create(prefab).Field("animatorMessageForwarder").SetValue(anim);
        }
        prefab.gameObject.AddComponent<StorageDestroyFixer>();
        RAPI.AddItemToBlockQuadType(i, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(i, RBlockQuadType.quad_foundation);
        RAPI.AddItemToBlockQuadType(i, RBlockQuadType.quad_table);
    }
}

public class StorageDestroyFixer : MonoBehaviour
{
    void OnDestroy()
    {
        Storage_Small block = GetComponent<Storage_Small>();
        if (Semih_Network.IsHost && block != null && block.GetInventoryReference() != null)
        {
            block.GetInventoryReference().allSlots.ForEach(slot =>
            {
                if (slot.HasValidItemInstance())
                {
                    Helper.DropItem(slot.itemInstance, transform.position, Vector3.zero, true);
                }
            });

        }
    }
}